;     *******************************************
;  ***  This program was written by student's of ***
; ***  Kirov Politechnical Institut Kalinin E.A.  ***
;  ***  This is a freeware. All rights reserved. ***
;     *******************************************
code	segment	para	public
	assume	ds:code,cs:code,ss:code
	org	100h
start:	jmp	main

screen_mode	db	(?)
DTA		db	43 dup(?)
file_name	db	40h dup(0)
pcx_fspec	db	'..\fontes\_08x16.fnt',0
fm	dw	?

get_file_name	proc	near
	cmp	file_name,0
	jnz	gpn2

	mov	ah,4eh		; find first
	lea	dx,pcx_fspec
	mov	cx,20h
	jmp	gpn3

gpn2:	mov	ah,4fh		; find next
	lea	dx,DTA

gpn3:	int	21h
	ret
get_file_name	endp

main:	mov	ah,1ah		; ⠭ p DTA
	lea	dx,DTA
	int	21h
	
	xor	ax,ax
	mov	es,ax
	mov	bx,449h
	mov	al,es:[bx]
	mov	screen_mode,al	; Save screen-mode
	mov	ah,0		;  and set 640*200-mode
	mov	al,6		;  of CGA-adapter
	int	10h		;  (2 colors)

again:	call	get_file_name
	jc	exit

	push	cs
	pop	es
	lea	si,pcx_fspec
	lea	di,file_name

lpf7:	lodsb			; p뫪  
	cmp	al,'*'		; pcx_fspec  file_name
	je	lpf8
	stosb
	jmp	lpf7
	
lpf8:	lea	si,DTA
	add	si,30		; si -> DTA [file_name]
	mov	cx,13
	rep	movsb		; p뫪  䠩

	lea	dx,file_name
	mov	ax,3d00h
	int	21h		; p⨥ 䠩
	mov	fm,ax		; 䠩 p

	mov	bx,fm
	lea	dx,buffer
	mov	ah,3fh
	mov	cx,length buffer
	int	21h
	
	mov	ah,3eh
	int	21h
	
	call	manager
	jmp	again
	
exit:	mov	al,screen_mode	; Return screen-mode
	xor	ah,ah
	int	10h
	int	20h

outbyte	proc	near
; procedure of print one pattern-byte at the screen
;	ah - byte-pattern
;	al - x-coordinate(0 - 79)
;	dx - y-coordinate(0 - 199)
	push	bx
	push	cx
	push	di
	push	es
	mov	bx,0b800h
	mov	es,bx
	cmp	dx,0
	jl	oexit
	cmp	dx,199
	jnle	oexit
	cmp	al,0
	jb	oexit
	cmp	al,79
	jnbe	oexit
	mov	di,dx
	and	di,0fffeh
	mov	cl,3h
	shl	di,cl
	mov	bx,di
	mov	cl,2h
	shl	di,cl
	add	di,bx
	mov	cx,ax
	xor	ch,ch
	add	di,cx
	test	dx,1h
	jz	o1
	add	di,2000h
o1:	mov	byte ptr es:[di],ah
oexit:	pop	es
	pop	di
	pop	cx
	pop	bx
	ret
outbyte	endp

clrscr  proc	near
	push	ax
	push	bx
	push	cx
	push	dx
	push	di
	push	es
	mov	ax,0b800h
	mov	es,ax
	xor	ax,ax
	mov	cx,2000h
	rep	stosw	
	pop	es
	pop	di
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
clrscr	endp

manager proc	near
; this procedure execute management of pattern with keys-help
	push	ax
	push	bx
	push	cx
	push	dx
	push	es
	mov	ax,cs
	add	ax,50h
	mov	es,ax
	jmp	tc

loopmng:
	mov	ah,1
	int	16h
	jnz	analys
	mov	ah,0
	int	16h

analys:	cmp	al,1bh
	jnz	t0
	jmp	mngexit

t0:	cmp	al,0h
	jnz	tc
	cmp	ah,75
	jnz	t1
	mov	ax,es
	sub	ax,50
	mov	es,ax
	jmp	tc

t1:	cmp	ah,77
	jnz	t2
	mov	ax,es
	add	ax,50
	mov	es,ax
	jmp	tc

t2:	cmp	ah,73
	jz	t3
	cmp	ah,72
	jnz	t4

t3:	mov	ax,es
	sub	ax,1000
	mov	es,ax
	jmp	tc

t4:	cmp	ah,81
	jz	t5
	cmp	ah,80
	jnz	tc

t5:	mov	ax,es
	add	ax,1000
	mov	es,ax

;---------------------
tc:	xor	si,si
	xor	al,al
	mov	cx,80

l1:	push	cx
	xor	dx,dx
	mov	cx,128
	
l2:	mov	ah,es:[si]
	inc	si
	call	outbyte
	inc	dx
	loop	l2
	
	add	al,1
	pop	cx
	loop	l1
	jmp	loopmng

mngexit:
	pop	es
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
manager	endp                             

	even
	org	500h
buffer	db	59000 dup(8)
code	ends                             
	end	start
