;     *******************************************
;  ***  This program was written by student's of ***
; ***  Kirov Politechnical Institut Kalinin E.A.  ***
;  ***  This is a freeware. All rights reserved. ***
;     *******************************************
code	segment	para	public
	assume	ds:code,cs:code,ss:code
	org	100h
start:	jmp	main
screen_mode	db	(?)
main	proc	far
	push	ds
	mov	ax,0h
	push	ax
	mov	ax,code
	mov	ds,ax
again:	push	es
	xor	ax,ax
	mov	es,ax
	int	16h
	mov	bx,449h
	mov	al,es:[bx]
	mov	screen_mode,al	; Save screen-mode
	mov	ah,0		;  and set 640*200-mode
	mov	al,6		;  of CGA-adapter
	int	10h		;  (2 colors)
	call	manager
	mov	al,screen_mode	; Return screen-mode
	xor	ah,ah
	int	10h
	pop	es
	jmp	again
	ret
main	endp

outbyte	proc	near
; procedure of print one pattern-byte at the screen
;	ah - byte-pattern
;	al - x-coordinate(0 - 79)
;	dx - y-coordinate(0 - 199)
	push	bx
	push	cx
	push	di
	push	es
	mov	bx,0b800h
	mov	es,bx
	cmp	dx,0h
	jl	oexit
	cmp	dx,0c7h
	jnle	oexit
	cmp	al,0h
	jb	oexit
	cmp	al,4fh
	jnbe	oexit
	mov	di,dx
	and	di,0fffeh
	mov	cl,3h
	shl	di,cl
	mov	bx,di
	mov	cl,2h
	shl	di,cl
	add	di,bx
	mov	cx,ax
	xor	ch,ch
	add	di,cx
	test	dx,1h
	jz	o1
	add	di,2000h
o1:	mov	byte ptr es:[di],ah
oexit:	pop	es
	pop	di
	pop	cx
	pop	bx
	ret
outbyte	endp

clrscr  proc	near
	push	ax
	push	bx
	push	cx
	push	dx
	push	di
	push	es
	mov	ax,0b800h
	mov	es,ax
	xor	ax,ax
	mov	cx,2000h
	rep	stosw	
	pop	es
	pop	di
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
clrscr	endp

manager proc	near
; this procedure execute management of pattern with keys-help
	push	ax
	push	bx
	push	cx
	push	dx
	push	es
	xor	bx,bx
	mov	es,bx
loopmng:
	mov	ah,0bh
	int	21h
	cmp	al,0h
	jz	tc
	mov	ah,0h
	int	16h
analys:	cmp	al,20h
	jz	mngexit
	cmp	al,0h
	jnz	tc
	cmp	ah,4bh
	jnz	t1
	mov	ax,es
	add	ax,39h
	mov	es,ax
	jmp	tc
t1:	cmp	ah,4dh
	jnz	t2
	mov	ax,es
	sub	ax,39h
	mov	es,ax
	jmp	tc
t2:	cmp	ah,49h
	jz	t3
	cmp	ah,48h
	jnz	t4
t3:	mov	ax,es
	sub	ax,8e8h
	mov	es,ax
	jmp	tc
t4:	cmp	ah,51h
	jz	t5
	cmp	ah,50h
	jnz	tc
t5:	mov	ax,es
	add	ax,8e8h
	mov	es,ax
;	call	clrscr
tc:	xor	si,si
	xor	ax,ax
	mov	cx,50h
l1:	push	cx
	xor	dx,dx
	mov	cx,1c8h
l2:	xchg	ah,al
	push	ds
	mov	bx,es
	mov	ds,bx
	lodsb	
	pop	ds
	xchg	ah,al
	call	outbyte
	inc	dx
	loop	l2
	inc	al
	pop	cx
	loop	l1
	jmp	loopmng
mngexit:
	pop	es
	pop	dx
	pop	cx
	pop	bx
	pop	ax
	ret
manager	endp                             

multb	proc	near
	;AX:=AL*AH
	cmp	al,0h
	jz	ex_multb
	cmp	ah,0h
	jz	ex_multb
	push	bx
	push	dx
	mov	bx,ax
	xor	ax,ax
	mov	dl,bh
	xor	bh,bh
l_m:	shr	dl,1h
	jc	m_1
	shl	bx,1h
	jmp	l_m
m_1:	add	ax,bx
	cmp	dl,0h
	jz	m_2
	shl	bx,1h
	jmp	l_m
m_2:	pop	dx
	pop	bx
ex_multb:
	ret
multb	endp

code	ends                             
	END	start
